<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Frame.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Frame.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Frame.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2006 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">import</span> sys, time</span>
<a id="line10"></a><span class="lineno">10</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Frame/Frame.html">Frame</a>:</span>
<a id="line12"></a><span class="lineno">12</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A Frame is a mediator for views that get displayed in it (as well</span></span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="py-string">    as other frames. It supports the creation of links across views.&quot;&quot;&quot;</span></span>
<a id="line14"></a><span class="lineno">14</span>
<a id="line15"></a><span class="lineno">15</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Frame/Frame.html#__init__">__init__</a>(self, processor, views, noframes = False):</span>
<a id="line16"></a><span class="lineno">16</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">        self.processor = processor</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">        self.views = views</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">        self.noframes = noframes</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">        <span class="py-keyword">if</span> self.noframes:</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">            self.views[0].main = True</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">        <span class="py-keyword">for</span> v <span class="py-keyword">in</span> self.views:</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">            v.register(self)</span>
<a id="line24"></a><span class="lineno">24</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Frame/Frame.html#process">process</a>(self):</span>
<a id="line26"></a><span class="lineno">26</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">        <span class="py-keyword">for</span> v <span class="py-keyword">in</span> self.views:</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">            v.register_filenames()</span>
<a id="line29"></a><span class="lineno">29</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">        <span class="py-keyword">for</span> v <span class="py-keyword">in</span> self.views:</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">            <span class="py-keyword">if</span> self.processor.profile:</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">'Time for %s:'</span>%v.__class__.__name__,</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">                sys.stdout.flush()</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">                start_time = time.time()</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">            v.process()</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">            <span class="py-keyword">if</span> self.processor.profile:</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">'%f seconds'</span>%(time.time() - start_time)</span>
<a id="line38"></a><span class="lineno">38</span>
<a id="line39"></a><span class="lineno">39</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Frame/Frame.html#navigation_bar">navigation_bar</a>(self, view):</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Generates a navigation bar for the given view.&quot;&quot;&quot;</span></span>
<a id="line42"></a><span class="lineno">42</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">        <span class="py-comment"># Only include views that set a root title.</span></span>
<a id="line44"></a><span class="lineno">44</span><span class="line">        views = [v <span class="py-keyword">for</span> v <span class="py-keyword">in</span> self.views <span class="py-keyword">if</span> v.root()[1]]</span>
<a id="line45"></a><span class="lineno">45</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">        <span class="py-keyword">def</span> item(v):</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">            <span class="py-string">&quot;&quot;&quot;Generate a navigation bar item.&quot;&quot;&quot;</span></span>
<a id="line48"></a><span class="lineno">48</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">            url, label = v.root()</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">            <span class="py-keyword">if</span> url == view.filename():</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">                <span class="py-keyword">return</span> span(<span class="py-string">'selected'</span>, label) + <span class="py-string">'\n'</span></span>
<a id="line52"></a><span class="lineno">52</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">                <span class="py-keyword">return</span> span(<span class="py-string">'normal'</span>, href(rel(view.filename(), url), label)) + <span class="py-string">'\n'</span></span>
<a id="line54"></a><span class="lineno">54</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">        items = [item(v) <span class="py-keyword">for</span> v <span class="py-keyword">in</span> views]</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">        <span class="py-keyword">return</span> items <span class="py-keyword">and</span> div(<span class="py-string">'navigation'</span>, <span class="py-string">'\n'</span> + <span class="py-string">''</span>.join(items)) <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line57"></a><span class="lineno">57</span>
<a id="line58"></a><span class="lineno">58</span>
<a id="line59"></a><span class="lineno">59</span>
<a id="line60"></a><span class="lineno">60</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
